#ifndef _INIT_H
#define _INIT_H

#include <sam9407.h>

#define NumberOf(vec) (sizeof(vec)/sizeof(*(vec)))

#define SAM_CONFIG_FILE		"/etc/sam9407.conf"

typedef struct {
  int verbose, initialize;
  char *device, *firmware, *soundbanks[SAM_NROF_SBANKS];
} Options;

extern char *prgName;
extern int mixerFd;

extern Options options;

void fatal(int perr, char *format, ...);
void *xmalloc(int size);
void *xrealloc(void *ptr, int size);
char *xstrdup(char *str);

void parseConfigFile(int cardNr);
void adjustMixer(void);

#endif /* _INIT_H */
