#ifndef _MIXER_H
#define _MIXER_H

#include "driver.h"

int samOpenMixer(struct inode *inode, struct file *file, SamCard *card, mode_t mode, char *closure);
void samReleaseMixer(struct inode *inode, struct file *file, SamCard *card, mode_t mode, char *closure);
int samReadMixer(struct inode *inode, struct file *file, char *buf, int count, SamCard *card, char *closure);
#if LINUX_VERSION_CODE>=0x20200
unsigned samPollMixer(struct inode *inode, struct file *file, poll_table *wait, SamCard *card, mode_t mode, char *closure);
#else /* Linux 2.0 */
int samSelectMixer(struct inode *inode, struct file *file, int type, select_table *wait, SamCard *card, char *closure);
#endif /* Linux 2.0 */
int samIoctlMixer(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg, SamCard *card, mode_t mode, char *closure, int callNr);

int samFirmwareLoad(SamCard *card, SamFirmware *firmware);

int samRelocateMidiTable(SamCard *card);
int samSBankLoad(SamCard *card, SamSoundBank *bank);
int samSBankUnload(SamCard *card, unsigned char *id);
int samSBankPrioChange(SamCard *card, SamSoundBankPrio *prio);
int samSBankInfo(SamCard *card, SamSoundBankInfo *info);

#endif /* _MIXER_H */
