.TH sam9407 4 "3 Jan 1999" Linux "Linux Programmer's Manual"
.SH NAME
sam9407 \- sam9407 device driver
.SH DESCRIPTION
\fBsam9407\fR is a device driver for sam9407 based soundcards.

.SH SYNOPSIS
.B "#include <sam9407.h>"

.SH "SUPPORTED CARDS"
.IP * 2
Hoontech ST128 Gold & Ruby
.IP *
Guillemot Maxi Sound 64 Home Studio Pro
.IP *
Terratec EWS64S

.SH "IOCTL(/dev/sam\fR[0-9]\fB_mixer)"
.TP
.B "SAM_IOC_DRIVER_INFO (IOR)"
Return information about the hardware and firmware located at device.
The parameter is of type \fBSamDriverInfo *\fR.

.TP
.B "SAM_IOC_FIRMWARE_LOAD (IOW)"
Upload the firmware defined by parameter of type \fBSamFirmware *\fR
into the card. The \fBsize\fR field defines the number of words (2 bytes)
stored at \fBdata\fR. Depending on how the module has been compiled,
this might require root priviledge.
This operation will return -EBUSY, in case some process is still using
the soundcard.

.TP
.B "SAM_IOC_MIXER_GET (IOWR)"
Retrieve mixer values, that will be stored in the vector passed
as parameter of type \fBSamMixerValue *\fR.
Each element in this vector must have a valid \fBid\fR field set.
The last element in this vector must have an \fBid\fR field of value
\fBSAM_MIXER_ID_SENTINEL\fR. Only those values supported by this device
will be modified (see \fBSAM_IOC_MIXER_INFO\fR).

.TP
.B "SAM_IOC_MIXER_SET (IOW)"
Set mixer values, taken from the vector passed as a parameter
of type \fBSamMixerValue *\fR. Each element in this vector
must have a vaild \fBid\fR and \fBvalue\fR field.
The last element in this vector must have an \fBid\fR field of value
\fBSAM_MIXER_ID_SENTINEL\fR. Only those values supported by this device
will be set (see \fBSAM_IOC_MIXER_INFO\fR).
Some mixer controls, that would reset the firmware, can't be set while
the device is currently used. The ioctl will return -EBUSY in those cases.
Many mixer settings will be lost after issuing a reset control change.
Refer to the SAM9407 firmware manual for further details.

.TP
.B "SAM_IOC_MIXER_INFO (IOWR)"
Query supported mixer types. If an element in the vector passed
as a parameter of type \fBSamMixerValue *\fR is supported
by the hardware, the \fBvalue\fR field will be set to a
non-zero value. If it's not supported, value will be zero.
The last element in this vector must have an \fBid\fR field of value
\fBSAM_MIXER_ID_SENTINEL\fR.

.TP
.B "SAM_IOC_BANK_LOAD (IOW)"
Load a soundbank. The parameter of type \fBSamSoundBank *\fR needs to carry
the \fBid\fR of the soundbank and a valid \fBdata\fR and \fBsize\fR (in bytes)
field. If a soundbank was already loaded at slot number \fBid\fR, it will be discarded
first.

.TP
.B "SAM_IOC_BANK_UNLOAD (IOW)"
Unload a soundbank with the id passed as parameter of type \fBunsigned char *\fR.

.TP
.B "SAM_IOC_BANK_PRIO_CHG (IOW)"
Change the priority of a soundbank. The new priority and soundbank identifier
are passed a pointer of type \fBSamSoundBankPrio\fR.

.TP
.B "SAM_IOC_BANK_INFO (IOR)"
Query all soundbanks. The name of the soundbanks and their respective priorities
will be stored to the vector passed as parameter.
The caller needs to have room for \fBSAM_NROF_SBANKS\fR elements of type
\fBSamSoundBankInfo\fR in this vector.

.SH "IOCTL(/dev/sam\fR[0-9]\fB_{dsp,audio})"
.TP
.B "SAM_IOC_VOLUME_GET (IOR)"
Query the current volume settings per channel.
The parameter is of type \fBSamVolume *\fR.

.TP
.B "SAM_IOC_VOLUME_SET (IOW)"
Change current volume settings per channel.
It's possible to adjust the \fBleft\fR, \fBright\fR,
\fBauxLeft\fR and \fBauxRight\fR volume.
The parameter is of type \fBSamVolume *\fR.

.SH "NOTIFICATIONS"
Whenever a mixer control value changes, or a new firmware is uploaded,
a notification is sent to the user process, which it can read(2) from
the \fB/dev/sam\fR[0-9]\fB_mixer\fR device. Each byte (of type \fBsigned char\fR)
relates to an identifier of the value that has changed. Values being
\fB>=0\fR correspond to the \fBSamMixerId\fR type.
Values \fB<0\fR refer to any of the constants
\fBSAM_MIXER_FIRMWARE_CHANGED\fR or
\fBSAM_MIXER_SBANK_CHANGED\fR.

.SH "SEE ALSO"
sam9407(8), sam9407.conf(5), x9407(1)

.SH AUTHOR
Gerd Rausch <gerd@alf.gun.de>
