/*
  Copyright (C) 1998, 1999 Gerd Rausch <gerd@alf.gun.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>

#include "mixerctl.h"

SamMixerAssoc samMixerAssoc[]={
  { "MASTER_VOL", SAM_MIXER_ID_MASTER_VOL },
  { "REC_MODE", SAM_MIXER_ID_REC_MODE },
  { "REC_VOL", SAM_MIXER_ID_REC_VOL },
  { "EQ_LBL", SAM_MIXER_ID_EQ_LBL },
  { "EQ_MLBL", SAM_MIXER_ID_EQ_MLBL },
  { "EQ_MHBL", SAM_MIXER_ID_EQ_MHBL },
  { "EQ_HBL", SAM_MIXER_ID_EQ_HBL },
  { "EQ_LBR", SAM_MIXER_ID_EQ_LBR },
  { "EQ_MLBR", SAM_MIXER_ID_EQ_MLBR },
  { "EQ_MHBR", SAM_MIXER_ID_EQ_MHBR },
  { "EQ_HBR", SAM_MIXER_ID_EQ_HBR },
  { "EQF_LB", SAM_MIXER_ID_EQF_LB },
  { "EQF_MLB", SAM_MIXER_ID_EQF_MLB },
  { "EQF_MHB", SAM_MIXER_ID_EQF_MHB },
  { "EQF_HB", SAM_MIXER_ID_EQF_HB },
  { "AUD_SEL", SAM_MIXER_ID_AUD_SEL },
  { "AUD_GAINL", SAM_MIXER_ID_AUD_GAINL },
  { "AUD_GAINR", SAM_MIXER_ID_AUD_GAINR },
  { "AUDCHR_SEND", SAM_MIXER_ID_AUDCHR_SEND },
  { "GMREV_SEND", SAM_MIXER_ID_GMREV_SEND },
  { "GMCHR_SEND", SAM_MIXER_ID_GMCHR_SEND },
  { "AUDREV_SEND", SAM_MIXER_ID_AUDREV_SEND },
  { "ECH_LEV", SAM_MIXER_ID_ECH_LEV },
  { "ECH_TIM", SAM_MIXER_ID_ECH_TIM },
  { "ECH_FEED", SAM_MIXER_ID_ECH_FEED },
  { "SUR_VOL", SAM_MIXER_ID_SUR_VOL },
  { "SUR_DEL", SAM_MIXER_ID_SUR_DEL },
  { "SUR_INP", SAM_MIXER_ID_SUR_INP },
  { "SUR_24", SAM_MIXER_ID_SUR_24 },
  { "AUDL_VOL", SAM_MIXER_ID_AUDL_VOL },
  { "AUDR_VOL", SAM_MIXER_ID_AUDR_VOL },
  { "AUDL_PAN", SAM_MIXER_ID_AUDL_PAN },
  { "AUDR_PAN", SAM_MIXER_ID_AUDR_PAN },
  { "GM_VOL", SAM_MIXER_ID_GM_VOL },
  { "GM_PAN", SAM_MIXER_ID_GM_PAN },
  { "REV_VOL", SAM_MIXER_ID_REV_VOL },
  { "CHR_VOL", SAM_MIXER_ID_CHR_VOL },
  { "GM_POST", SAM_MIXER_ID_GM_POST },
  { "WAVE_POST", SAM_MIXER_ID_WAVE_POST },
  { "MOD_POST", SAM_MIXER_ID_MOD_POST },
  { "AUDECH_POST", SAM_MIXER_ID_AUDECH_POST },
  { "EFF_POST", SAM_MIXER_ID_EFF_POST },
  { "REV_TYPE", SAM_MIXER_ID_REV_TYPE },
  { "CHR_TYPE", SAM_MIXER_ID_CHR_TYPE },
  { "CHR_DEL", SAM_MIXER_ID_CHR_DEL },
  { "CHR_FEED", SAM_MIXER_ID_CHR_FEED },
  { "CHR_RATE", SAM_MIXER_ID_CHR_RATE },
  { "CHR_DEPTH", SAM_MIXER_ID_CHR_DEPTH },
  { "REV_TIME", SAM_MIXER_ID_REV_TIME },
  { "REV_FEED", SAM_MIXER_ID_REV_FEED },
  { "REC_CFG", SAM_MIXER_ID_REC_CFG, 1 },
  { "AUD_ONOFF", SAM_MIXER_ID_AUD_ONOFF, 1 },
  { "ECH_ONOFF", SAM_MIXER_ID_ECH_ONOFF, 1 },
  { "REV_ONOFF", SAM_MIXER_ID_REV_ONOFF, 1 },
  { "CHR_ONOFF", SAM_MIXER_ID_CHR_ONOFF, 1 },
  { "EQU_TYPE", SAM_MIXER_ID_EQU_TYPE, 1 },
  { "SUR_ONOFF", SAM_MIXER_ID_SUR_ONOFF, 1 },
  { "WAVE_ASS", SAM_MIXER_ID_WAVE_ASS, 1 },
  { "MOD_ASS", SAM_MIXER_ID_MOD_ASS, 1 },

  { "WAV_VOL0", SAM_MIXER_ID_WAV_VOL0 },
  { "WAV_VOL1", SAM_MIXER_ID_WAV_VOL1 },
  { "WAV_VOL2", SAM_MIXER_ID_WAV_VOL2 },
  { "WAV_VOL3", SAM_MIXER_ID_WAV_VOL3 },
  { "WAV_VOL4", SAM_MIXER_ID_WAV_VOL4 },
  { "WAV_VOL5", SAM_MIXER_ID_WAV_VOL5 },
  { "WAV_VOL6", SAM_MIXER_ID_WAV_VOL6 },
  { "WAV_VOL7", SAM_MIXER_ID_WAV_VOL7 },
  { "WAV_VOL8", SAM_MIXER_ID_WAV_VOL8 },

  { "WAV_AUX_VOL0", SAM_MIXER_ID_WAV_AUX_VOL0 },
  { "WAV_AUX_VOL1", SAM_MIXER_ID_WAV_AUX_VOL1 },
  { "WAV_AUX_VOL2", SAM_MIXER_ID_WAV_AUX_VOL2 },
  { "WAV_AUX_VOL3", SAM_MIXER_ID_WAV_AUX_VOL3 },
  { "WAV_AUX_VOL4", SAM_MIXER_ID_WAV_AUX_VOL4 },
  { "WAV_AUX_VOL5", SAM_MIXER_ID_WAV_AUX_VOL5 },
  { "WAV_AUX_VOL6", SAM_MIXER_ID_WAV_AUX_VOL6 },
  { "WAV_AUX_VOL7", SAM_MIXER_ID_WAV_AUX_VOL7 },
  { "WAV_AUX_VOL8", SAM_MIXER_ID_WAV_AUX_VOL8 },

  { "SB_MASTER",    SB_MIXER_ID_MASTER },
  { "SB_WAV",       SB_MIXER_ID_WAV    },
  { "SB_FM",        SB_MIXER_ID_FM     },
  { "SB_CD",        SB_MIXER_ID_CD     },
  { "SB_LINE",      SB_MIXER_ID_LINE   },
  { "SB_MIC",       SB_MIXER_ID_MIC    },


  { NULL } /* sentinel */
};
