.TH sam9407 5 "3 Jan 1999" Linux "Linux Programmer's Manual"
.SH NAME
sam9407.conf \- sam9407 config file
.SH DESCRIPTION
\fB/etc/sam9407.conf\fR is the configuration file for
\fBsam9407(1)\fR.
It contains path information about firmware, soundbanks
and mixer settings for various sam9407 based soundcards.
Each line contains a keyword and a value, which are separated
by at least one whitespace character.
Lines beginning with \fB#\fR are treated as comments.

.SH KEYWORDS
.TP
.B "card \fIcard#\fR"
The definitions following this line are regarded to belong
to \fIcard#\fR. This is useful if you have more than one
sam9407 based soundcard installed.

.TP
.B "firmware \fIpath\fR"
This defines the firmware file \fBsam9407\fR should
downloaded to the soundcard, if needed.

.TP
.B "soundbank \fIpath\fR"
This line will ensure that the specified soundbank will
be loaded to soundbank number \fB0\fR.

.TP
.B "soundbank\fI[0-9]\fR \fIpath\fR"
This line will ensure that the specified soundbank will
be loaded to soundbank number specified.

.TP
.B "\fImixer-ctl\fR \fIvalue\fR"
All mixer controls are uppercase keywords and take numeric
values as arguments. You can get the complete list of mixer
controls from \fBsam9407.h\fR or by running \fBx9407\fR and
saving the current settings to a file.

.SH "SEE ALSO"
sam9407(8), x9407(1), sam9407(4)

.SH AUTHOR
Gerd Rausch <gerd@alf.gun.de>
