
#ifndef __CONTROLS_H
#define __CONTROLS_H


#define MAXCONTROLS     110

//=========================================================
// Mixer control ID
//=========================================================
#define MX_AUDL_VOL         0  //lr
#define MX_GM_VOL           1
#define MX_SUR_VOL          2

#define MX_REV_VOL          3
#define MX_CHR_VOL          4
#define MX_TRANS_VAL        5
#define MX_TRANS_REVSEND    6
#define MX_TRANS_CHRSEND    7

#define MX_EQ_LBL           8  //lr
#define MX_EQ_MLBL          9  //lr
#define MX_EQ_MHBL          10  //lr
#define MX_EQ_HBL           11  //lr

#define MX_EQF_LB           12
#define MX_EQF_MLB          13
#define MX_EQF_MHB          14
#define MX_EQF_HB           15

#define MX_AUD_GAINL        16  //lr

#define MX_GMREV_SEND       17
#define MX_GMCHR_SEND       18
#define MX_AUDREV_SEND      19
#define MX_ECH_LEV          20
#define MX_ECH_TIM          21
#define MX_ECH_FEED         22

#define MX_SUR_DEL          23
#define MX_SUR_INP          24

#define MX_AUDR_VOL		 25  //lr

#define MX_GM_PAN           26
#define MX_CHR_DEL          27
#define MX_CHR_FEED         28
#define MX_CHR_RATE         29
#define MX_CHR_DEPTH        30
#define MX_REV_TIME         31
#define MX_REV_FEED         32
#define MX_WAVE_ASS         33
#define MX_MOD_ASS          34
#define MX_GM_POST          35
#define MX_WAVE_POST        36
#define MX_MOD_POST         37
#define MX_AUDECH_POST      38
#define MX_EFF_POST         39
#define MX_ECH_ONOFF        40
#define MX_REV_ONOFF        41
#define MX_CHR_ONOFF        42
#define MX_SUR_ONOFF        43
#define MX_AUD_ONOFF        44
#define MX_REC_MODE         45
#define MX_AUD_SEL          46
#define MX_SUR_24           47
#define MX_REV_TYPE         48
#define MX_CHR_TYPE         49
#define MX_EQU_TYPE         50
#define MX_TRANS_ONOFF      51
#define MX_TRANS_GMCH       52
#define MX_W_VOLLEFT0       53  //lr
#define MX_W_VOLLEFT1       54  //lr
#define MX_W_VOLLEFT2       55  //lr
#define MX_W_VOLLEFT3       56  //lr
#define MX_W_VOLLEFT4       57  //lr
#define MX_W_VOLLEFT5       58  //lr
#define MX_W_VOLLEFT6       59  //lr
#define MX_W_VOLLEFT7       60  //lr
#define MX_W_VOLAUXLEFT0    61  //lr
#define MX_W_VOLAUXLEFT1    62  //lr
#define MX_W_VOLAUXLEFT2    63  //lr
#define MX_W_VOLAUXLEFT3    64  //lr
#define MX_W_VOLAUXLEFT4    65  //lr
#define MX_W_VOLAUXLEFT5    66  //lr
#define MX_W_VOLAUXLEFT6    67  //lr
#define MX_W_VOLAUXLEFT7    68  //lr
#define MX_W_PITCH          69
#define MX_W_FILT_FC        70
#define MX_W_FILT_Q         71
#define MX_VOI_VOL          72
#define MX_VOI_MAIN         73
#define MX_VOI_PITCH        74
#define MX_VOI_AUX          75
#define MX_VOI_FILT         76
#define MX_W_VOLLEFT8       77  //lr
#define MX_W_VOLAUXLEFT8    78  //lr

// mixer.h
//#define MUX_WAVEIN        79
//#define MUX_VOICEIN       80

#define MX_ECH_SILENT       81
#define MX_EFF_SILENT       82
#define MX_EQU_SILENT       83

#define MX_AUDCHR_SEND      84

#define MX_MASTER_VOL       85

#define MX_W_PITCH0         86
#define MX_W_PITCH1         87
#define MX_W_PITCH2         88
#define MX_W_PITCH3         89
#define MX_W_PITCH4         90
#define MX_W_PITCH5         91
#define MX_W_PITCH6         92
#define MX_W_PITCH7         93

#define MX_W_FC0            94
#define MX_W_FC1            95
#define MX_W_FC2            96
#define MX_W_FC3            97
#define MX_W_FC4            98
#define MX_W_FC5            99
#define MX_W_FC6           100
#define MX_W_FC7           101

#define MX_W_Q0            102
#define MX_W_Q1            103
#define MX_W_Q2            104
#define MX_W_Q3            105
#define MX_W_Q4            106
#define MX_W_Q5            107
#define MX_W_Q6            108
#define MX_W_Q7            109


//=========================================================
// Dream Mixer controls
//=========================================================
#define WRT_MEM         0x1
#define RD_MEM          0x2
#define GET_MMT         0x3
#define SET_MMT         0x4

#define MASTER_VOL		0x7
#define REC_MODE		0x8

#define TRANS_ONOFF  	0x0B
#define TRANS_GMCH      0x0C
#define TRANS_VAL       0x0D
#define TRANS_REVSEND   0x0E
#define TRANS_CHRSEND   0x0F

#define EQ_LBL          0x10
#define EQ_MLBL         0x11
#define EQ_MHBL         0x12
#define EQ_HBL          0x13
#define EQ_LBR          0x14
#define EQ_MLBR         0x15
#define EQ_MHBR         0x16
#define EQ_HBR          0x17
#define EQF_LB          0x18
#define EQF_MLB         0x19
#define EQF_MHB         0x1A
#define EQF_HB          0x1B

#define AUD_SEL         0x20
#define AUD_GAINL       0x21
#define AUD_GAINR       0x22

#define AUDCHR_SEND     0x24

#define GMREV_SEND 		0x25
#define GMCHR_SEND      0x26
#define AUDREV_SEND     0x27

#define ECH_LEV         0x28
#define ECH_TIM         0x29
#define ECH_FEED        0x2A

#define SUR_VOL         0x30
#define SUR_DEL         0x31
#define SUR_INP         0x32
#define SUR_24          0x33

#define AUDL_VOL        0x34
#define AUDR_VOL        0x35
#define AUDL_PAN        0x36
#define AUDR_PAN        0x37

#define GM_VOL          0x38
#define GM_PAN          0x39

#define REV_VOL         0x3A
#define CHR_VOL         0x3B

#define EN_MIDOUT       0x3D
#define UART_MOD        0x3F
#define GEN_INT         0x48

#define WAVE_ASS        0x60
#define MOD_ASS         0x61

#define GM_POST         0x62
#define WAVE_POST       0x63
#define MOD_POST        0x64
#define AUDECH_POST     0x65
#define EFF_POST        0x66

#define ECH_ONOFF       0x68
#define REV_TYPE        0x69
#define CHR_TYPE        0x6A
#define EQU_TYPE        0x6B

#define REV_ONOFF       0x6C
#define CHR_ONOFF       0x6D
#define SUR_ONOFF       0x6E
#define AUD_ONOFF       0x6F

#define HOT_RES         0x70
#define DOS_MODE        0x71

#define CHR_DEL         0x74
#define CHR_FEED        0x75
#define CHR_RATE        0x76
#define CHR_DEPTH       0x77
#define REV_TIME        0x78
#define REV_FEED        0x79

#define EN_CONTROL      0xBE
#define RESET           0xFF

#define W_OPEN          0x40
#define W_CLOSE         0x41
#define W_START         0x42
#define END_XFER        0x43
#define W_PITCH         0x44
#define W_VOLLEFT       0x45
#define W_VOLRIGHT      0x46
#define W_VOLAUXLEFT    0x47
#define W_VOLAUXRIGHT   0x49
#define W_FILT_FC       0x4A
#define W_FILT_Q        0x4B

#define GET_VOI         0x51
#define VOI_OPEN        0x52
#define VOI_CLOSE       0x53
#define VOI_START       0x54
#define VOI_STOP        0x55
#define VOI_VOL         0x56
#define VOI_MAIN        0x57
#define VOI_PITCH       0x58
#define VOI_AUX         0x59
#define VOI_FILT        0x5A
#define VOI_MEM         0x5B
#define GET_POS         0x5C
#define ADD_POS         0x5D

//=========================================================
// SB Pro Mixer saved value
//=========================================================
#define SB_MASTER		0x80
#define SB_WAV			0x81
#define SB_FM			0x82
#define SB_CD			0x83  // aux 1 cd
#define SB_LINE			0x84  // line tv
#define SB_MIC			0x85
#define SB_VCD			0x86  // aux 2 vcd

#define SB_3D_LEV		0x88  // aux 2 vcd
#define SB_3D_ONOFF		0x89  // aux 2 vcd

#define SB_MIDI			0x8a  // i2s
#define SB_ECHO			0x8b  // aux 1

//=========================================================
// Memory Mapping Table Types - MMT
//=========================================================

#define MMT_MEM_SIZE	0x0
#define MMT_FREE		0x1
#define MMT_RESERVED	0x2
#define MMT_MMT			0x3
#define MMT_MIDI_MMT	0x4
#define MMT_MIDI_MMTEX  0x5
#define MMT_SOUND_PAR   0x10
#define MMT_SOUND_PCM   0x11
#define MMT_WAVE        0x20
#define MMT_MOD         0x30
#define MMT_EOM         0x7F

//=========================================================
// HW I/O Port
//=========================================================

//#define MPUBASE 0x330
#define DATA_PORT_MPU  (MPUBASE)
#define CNTL_PORT_MPU  (MPUBASE + 1)
#define DA16_PORT_MPU  (MPUBASE + 2)

//=========================================================
// Interrupts ID
//=========================================================
#define IRQ_BY_MIDI	0x00
#define IRQ_BY_WAV  0x10
#define IRQ_BY_MOD  0x20
#define IRQ_BY_GEN  0x30

//=========================================================
// Prototypes
//=========================================================

int  S94_DataRet( void );
void S94_SetGenDev( int cntl, unsigned int data );
void S94_SetGenDevACK( int cntl, unsigned int data );
int  S94_UART( void );
int  S94_GetActiveWave( void );
void S94_StandAlone( void );


//=========================================================
// General Prototypes
//=========================================================

int  SMAX( int reg );

//=========================================================
// WAV Prototypes
//=========================================================
#define W_MONO      0
#define W_STEREO    1
#define W_16BIT 	0
#define W_8BIT  	1

void Wav_Open ( int Channel, int IsMONOorSTR, int Is8or16, int Rate );
void Wav_OutClose ( int Channel );
void Wav_InClose ( int Channel );
void Wav_Start ( int Channel );
void Wav_End_Xfer ( int Channel );
void Wav_Pitch ( int Channel, unsigned int Rate );
void Wav_VolLeft ( int Channel, unsigned int Volume );
void Wav_VolRight ( int Channel, unsigned int Volume );
void Wav_VolAuxLeft ( int Channel, unsigned int Volume );
void Wav_VolAuxRight ( int Channel, unsigned int Volume );
void Wav_Filt_FC ( int Channel, unsigned int Volume );
void Wav_Filt_Q ( int Channel, unsigned int Volume );

//=========================================================
// MOD Prototypes
//=========================================================
int  Mod_Get_Voi( void );
void Mod_Voi_Open( int Voice );
void Mod_Voi_Close( int Voice );
void Mod_Voi_Start( int Voice );
void Mod_Voi_Stop( int Voice );
void Mod_Voi_Vol( int Voice, int Vol );
void Mod_Voi_Main( int Voice, int MainLeft, int MainRight ); //PAN
void Mod_Voi_Pitch( int Voice, int pitch );
void Mod_Voi_Aux( int Voice, int AuxLeft, int AuxRight ); //FX
void Mod_Voi_Filter( int Voice, int Q, int Fc );
void Mod_Voi_Mem( int Voice, int bit8or16, DWORD sstart, DWORD lpstart, DWORD lpend);


void MixerMessage( unsigned int id, unsigned int v );

#endif
